/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.seguridad;

import java.util.Calendar;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.util.Clients;
import org.zkoss.zul.Button;
import org.zkoss.zul.Intbox;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.Estacion;
import com.rjconsultores.ventaboletos.entidad.EstacionSitef;
import com.rjconsultores.ventaboletos.exception.BusinessException;
import com.rjconsultores.ventaboletos.service.EstacionService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxPuntoVenta;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;

/**
 * 
 * @author Administrador
 */
@Controller("editarEstacionController")
@Scope("prototype")
public class EditarEstacionController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private EstacionService estacionService;
	private MyListbox estacionList;
	private Button btnApagar;
	private Textbox txtDescEstacion;
	private Textbox txtDescMac;
	private Estacion estacion;
	private MyComboboxPuntoVenta cmbPuntoVenta;
	private Intbox txtNumEmpresa;
	private Intbox txtNumFilial;
	private Intbox txtNumPdv;
	private static Logger log = Logger.getLogger(EditarEstacionController.class);

	public Estacion getEstacion() {
		return estacion;
	}

	public void setEstacion(Estacion estacion) {
		this.estacion = estacion;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		estacion = (Estacion) Executions.getCurrent().getArg().get("estacion");
		estacionList = (MyListbox) Executions.getCurrent().getArg().get("estacionList");

		if (estacion.getEstacionId() == null) {
			btnApagar.setVisible(Boolean.FALSE);
		} else {
			// Convertendo a mascara em Hexa novamente.
			if (estacion.getDescmac() != null && !estacion.getDescmac().equals("")) {
				Long hx = Long.parseLong(estacion.getDescmac(), 10);
				String descMac = Long.toHexString(hx);
				while (descMac.length() < 12) {
					descMac = "0" + descMac;
				}
				// AABBCCDDEEFF
				// AA-BB-CC-DD-EE-FF
				descMac = descMac.substring(0, 2).concat("-").concat(descMac.substring(2, 4).concat("-")).concat(descMac.substring(4, 6)).concat("-").concat(descMac.substring(6, 8)).concat("-").concat(descMac.substring(8, 10).concat("-")).concat(descMac.substring(10, 12));

				txtDescMac.setText(descMac.toUpperCase());
			}
			
			if(estacion.getEstacionSitefId() == null){
				estacion.setEstacionSitefId(new EstacionSitef());
			}
			
		}

		txtDescEstacion.focus();
	}

	public void onClick$btnSalvar(Event ev) throws InterruptedException {
		Boolean salvar = false;
		cmbPuntoVenta.getValue(true);
		txtNumEmpresa.getValue();
		txtNumFilial.getValue();
		txtNumPdv.getValue();

		String descMac = txtDescMac.getText();

		estacion.setActivo(Boolean.TRUE);
		estacion.setFecmodif(Calendar.getInstance().getTime());
		estacion.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		estacion.setDescmac(estacionService.getDecimalMAC(descMac).toString());
		
		
		if((txtNumEmpresa.getValue() == null)&& (txtNumFilial.getValue()== null)&&(txtNumPdv.getValue()== null)){
			salvar = true;
			estacion.setEstacionSitefId(null);
		}else{

			if((!(txtNumEmpresa.getValue()== null))&& (!(txtNumFilial.getValue()== null))&&(!(txtNumPdv.getValue()== null))){
				salvar = true;
				estacion.getEstacionSitefId().setActivo(Boolean.TRUE);
				estacion.getEstacionSitefId().setFecmodif(Calendar.getInstance().getTime());
				estacion.getEstacionSitefId().setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
			}else{
				salvar = false;
			}
		}
		if(salvar){
			
			try {
				estacionService.suscribirActualizar(estacion);
				Messagebox.show(Labels.getLabel("editarEstacionController.MSG.suscribirOK"),
						Labels.getLabel("editarEstacionController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
	
				estacionList.updateItem(estacion);
	
				closeWindow();
			} catch (BusinessException e) {
				Messagebox.show(e.getMessage(), Labels.getLabel("editarEstacionController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			}
		}else{
			Messagebox.show(Labels.getLabel("editarEstacionController.MSG.sitef"),
					Labels.getLabel("editarEstacionController.window.title"),
					Messagebox.OK, Messagebox.EXCLAMATION);
		}
	}

	public void onClick$btnApagar(Event ev) {
		try {
			int resp = Messagebox.show(Labels.getLabel("editarEstacionController.MSG.borrarPergunta"),
					Labels.getLabel("editarEstacionController.window.title"),
					Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

			if (resp == Messagebox.YES) {
				estacionService.borrar(estacion);

				Messagebox.show(Labels.getLabel("editarEstacionController.MSG.borrarOK"),
						Labels.getLabel("editarEstacionController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);

				estacionList.removeItem(estacion);

				closeWindow();
			}
		} catch (Exception ex) {
			log.error(ex);
			Clients.alert(Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarEstacionController.window.title"), Messagebox.INFORMATION);
		}
	}
}
