package com.rjconsultores.ventaboletos.web.gui.controladores.sendaAmigo;

import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Datebox;
import org.zkoss.zul.Intbox;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Radio;

import com.rjconsultores.ventaboletos.entidad.Cliente;
import com.rjconsultores.ventaboletos.entidad.ClienteDireccion;
import com.rjconsultores.ventaboletos.entidad.MotivoViaje;
import com.rjconsultores.ventaboletos.entidad.TipoDomicilio;
import com.rjconsultores.ventaboletos.entidad.TipoOcupacion;
import com.rjconsultores.ventaboletos.service.ClienteService;
import com.rjconsultores.ventaboletos.service.MotivoViajeService;
import com.rjconsultores.ventaboletos.service.TipoDomicilioService;
import com.rjconsultores.ventaboletos.service.TipoOcupacionService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;


@Controller("editarClienteController")
@Scope("prototype")
public class EditarClienteController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	private static Logger log = Logger.getLogger(EditarClienteController.class);

	private ClienteService clienteService;
	private MotivoViajeService motivoViajeService;
	private TipoOcupacionService  tipoOcupacionService;
	private TipoDomicilioService tipoDomicilioService;
	private Cliente cliente;
	private MyListbox clienteList;
	private MyTextbox txtNombCliente;
	private MyTextbox txtApellidoPaterno;
	private MyTextbox txtApellidoMaterno;
	private MyTextbox txtNumRfc;
	private MyTextbox txtDescorreo;
	private MyTextbox txtNumCurp;
	private MyTextbox numtelefonouno;
	private MyTextbox numtelefonodos;
	private MyTextbox txtNumFax;
	private MyTextbox txtDireccionCalle;
	private MyTextbox txtDireccionNumero;
	private MyTextbox txtDireccionCompl;
	private MyTextbox txtDescCiudad;
	private MyTextbox txtDescColonia;
	private MyTextbox txtDescEstado;
	private MyTextbox txtCP;	
	private Datebox dateFecNacimiento;
	private Intbox txtCanthijos;
	private Intbox txtEdad;
	private Button btnApagar;
	private Radio radFeminino;
	private Radio radMasculino;
	private Combobox cmbDomicilio;
	private Combobox cmbOcupacion;
	private Combobox cmbMotivacionViaje;
	private List<MotivoViaje> lsMotivoViaje;
	private List<TipoOcupacion> lsTipoOcupacion;
	private List<ClienteDireccion> lsClienteDireccion;
	private List<TipoDomicilio> lsTipoDomicilio;
 


	public Cliente getCliente() {
		return cliente;
	}

	public void setCliente(Cliente cliente) {
		this.cliente = cliente;
	}



	public List<MotivoViaje> getLsMotivoViaje() {
		return lsMotivoViaje;
	}

	public void setLsMotivoViaje(List<MotivoViaje> lsMotivoViaje) {
		this.lsMotivoViaje = lsMotivoViaje;
	}

	public List<TipoOcupacion> getLsTipoOcupacion() {
		return lsTipoOcupacion;
	}

	public void setLsTipoOcupacion(List<TipoOcupacion> lsTipoOcupacion) {
		this.lsTipoOcupacion = lsTipoOcupacion;
	}

	public ClienteService getClienteService() {
		return clienteService;
	}

	public void setClienteService(ClienteService clienteService) {
		this.clienteService = clienteService;
	}

	public MotivoViajeService getMotivoViajeService() {
		return motivoViajeService;
	}

	public void setMotivoViajeService(MotivoViajeService motivoViajeService) {
		this.motivoViajeService = motivoViajeService;
	}
	

	public TipoOcupacionService getTipoOcupacionService() {
		return tipoOcupacionService;
	}

	public void setTipoOcupacionService(TipoOcupacionService tipoOcupacionService) {
		this.tipoOcupacionService = tipoOcupacionService;
	}
	

	public TipoDomicilioService getTipoDomicilioService() {
		return tipoDomicilioService;
	}

	public void setTipoDomicilioService(TipoDomicilioService tipoDomicilioService) {
		this.tipoDomicilioService = tipoDomicilioService;
	}

	public List<ClienteDireccion> getLsClienteDireccion() {
		return lsClienteDireccion;
	}

	public void setLsClienteDireccion(List<ClienteDireccion> lsClienteDireccion) {
		this.lsClienteDireccion = lsClienteDireccion;
	}

	public List<TipoDomicilio> getLsTipoDomicilio() {
		return lsTipoDomicilio;
	}

	public void setLsTipoDomicilio(List<TipoDomicilio> lsTipoDomicilio) {
		this.lsTipoDomicilio = lsTipoDomicilio;
	}
	

	public MyTextbox getTxtNombCliente() {
		return txtNombCliente;
	}

	public void setTxtNombCliente(MyTextbox txtNombCliente) {
		this.txtNombCliente = txtNombCliente;
	}

	public MyTextbox getTxtApellidoPaterno() {
		return txtApellidoPaterno;
	}

	public void setTxtApellidoPaterno(MyTextbox txtApellidoPaterno) {
		this.txtApellidoPaterno = txtApellidoPaterno;
	}

	public MyTextbox getTxtApellidoMaterno() {
		return txtApellidoMaterno;
	}

	public void setTxtApellidoMaterno(MyTextbox txtApellidoMaterno) {
		this.txtApellidoMaterno = txtApellidoMaterno;
	}

	public MyTextbox getTxtNumRfc() {
		return txtNumRfc;
	}

	public void setTxtNumRfc(MyTextbox txtNumRfc) {
		this.txtNumRfc = txtNumRfc;
	}

	public Intbox getTxtCanthijos() {
		return txtCanthijos;
	}

	public void setTxtCanthijos(Intbox txtCanthijos) {
		this.txtCanthijos = txtCanthijos;
	}

	public Intbox getTxtEdad() {
		return txtEdad;
	}

	public void setTxtEdad(Intbox txtEdad) {
		this.txtEdad = txtEdad;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		lsTipoOcupacion = tipoOcupacionService.obtenerTodos();
		lsMotivoViaje = motivoViajeService.obtenerTodos();
		lsTipoDomicilio = tipoDomicilioService.obtenerTodos();

		
		try {
			cliente = (Cliente) Executions.getCurrent().getArg().get("cliente");
			clienteList = (MyListbox) Executions.getCurrent().getArg().get("clienteList");

			if (cliente.getClienteId() == null) {
				btnApagar.setVisible(Boolean.FALSE);
				
			} else {
				cliente = clienteService.obtenerID(cliente.getClienteId());
				
				if(cliente.getMotivoviajeId() != null){
					cmbMotivacionViaje.setText(cliente.getMotivoviajeId().getDescMotivoViaje());
				}
				
				if(cliente.getTipoocupacionId()!= null){
					cmbOcupacion.setText(cliente.getTipoocupacionId().getDesctipo());
				}
				
				if(cliente.getIndsexo() != null){
					if (cliente.getIndsexo().equals("F")) {
						radFeminino.setChecked(true);
					} else if (cliente.getIndsexo().equals("M")) {
						radMasculino.setChecked(true);
					}
				}
				
				
				if(cliente.getLsClienteDireccion()!= null){
					if(cliente.getLsClienteDireccion().get(0)!= null){
						ClienteDireccion direccion = cliente.getLsClienteDireccion().get(0);
						if(direccion.getTipodomicilioId() != null){
							cmbDomicilio.setText(direccion.getTipodomicilioId().getDesctipo());
						}
						if(direccion.getDesccalle() != null){
							txtDireccionCalle.setText(direccion.getDesccalle());
						}
						if(direccion.getNumexterior() != null){
							txtDireccionNumero.setText(direccion.getNumexterior());
						}
						if(direccion.getDesccallecomp() != null){
							txtDireccionCompl.setText(direccion.getDesccallecomp());
						}
						if(direccion.getDesccolonia() != null){
							txtDescColonia.setText(direccion.getDesccolonia());
						}
						if(direccion.getDesciudad() != null){
							txtDescCiudad.setText(direccion.getDesciudad());
						}
						if(direccion.getDesestado() != null){
							txtDescEstado.setText(direccion.getDesestado());
						}
						
						if(direccion.getCodpostal() != null){
							txtCP.setText(direccion.getCodpostal());
						}
						if(direccion.getTipodomicilioId()!= null){
							cmbDomicilio.setText(direccion.getTipodomicilioId().getDesctipo());
						}
						
						
					}
					
				}
			}
			if (cliente.getLsClienteDireccion() == null) {
				cliente.setLsClienteDireccion(new ArrayList<ClienteDireccion>());
			}
			
			lsClienteDireccion = cliente.getLsClienteDireccion();
			txtNombCliente.focus();
			txtDireccionCalle.focus();
			
			
		} catch (Exception e) {
			log.error("Cliente: " + e);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarClienteController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}

		
	}
	

	
	public void setClienteDireccion(){
		ClienteDireccion direccion;
		if(lsClienteDireccion.isEmpty()){
			
			direccion = new ClienteDireccion();
			
		}else{
			direccion = lsClienteDireccion.get(0);
			lsClienteDireccion.remove(0);
		}
		
		cmbDomicilio.getValue();
		direccion.setDesccalle(txtDireccionCalle.getValue());
		direccion.setNumexterior(txtDireccionNumero.getValue());
		direccion.setDesccallecomp(txtDireccionCompl.getValue());
		direccion.setDesccolonia(txtDescColonia.getValue());
		direccion.setDesciudad(txtDescCiudad.getValue());
		direccion.setDesestado(txtDescEstado.getValue());
		direccion.setCodpostal(txtCP.getValue());
		direccion.setClienteId(cliente);
		if(cmbDomicilio.getSelectedItem() != null){
			direccion.setTipodomicilioId((TipoDomicilio) cmbDomicilio.getSelectedItem().getValue());
		}
		lsClienteDireccion.add(direccion);
	}
	

	public void onClick$btnSalvar(Event ev) throws InterruptedException {
		txtNombCliente.getValue();
		txtApellidoPaterno.getValue();
		txtApellidoMaterno.getValue();
		txtNumRfc.getValue();
		txtEdad.getValue();
		txtCanthijos.getValue();
		txtDescorreo.getValue();
		txtNumCurp.getValue();
		txtNumFax.getValue();
		dateFecNacimiento.getValue();
		numtelefonouno.getValue();
		numtelefonodos.getValue();
		cmbMotivacionViaje.getValue();
		cmbOcupacion.getValue();
		
		
		if (cliente.getClienteId() == null) {
			
			List<Cliente> lsCliente = clienteService.buscar(txtNombCliente.getValue());
			if (!lsCliente.isEmpty()) {
				Messagebox.show(
						Labels.getLabel("MSG.Registro.Existe"),
						Labels.getLabel("editarClienteController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
	
				return;
			
			}
			
		}
		setClienteDireccion();
		try {
			if (cliente.getClienteId() == null) {

				if (cmbMotivacionViaje.getSelectedItem() != null) {
					cliente.setMotivoviajeId((MotivoViaje) cmbMotivacionViaje.getSelectedItem().getValue());
				}
				
				if (cmbOcupacion.getSelectedItem() != null) {
					cliente.setTipoocupacionId((TipoOcupacion) cmbOcupacion.getSelectedItem().getValue());
				}
				
				if (radFeminino.isChecked()) {
					cliente.setIndsexo("F");
				} else if (radMasculino.isChecked()) {
					cliente.setIndsexo("M");
				}
				
				cliente.setLsClienteDireccion(lsClienteDireccion);

				clienteService.suscribir(cliente);
				clienteList.addItem(cliente);
			} else {
				clienteService.actualizacion(cliente);
				clienteList.updateItem(cliente);
			}

			Messagebox.show(
					Labels.getLabel("editarClienteController.MSG.suscribirOK"),
					Labels.getLabel("editarClienteController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);

			closeWindow();

		} catch (Exception ex) {
			log.error("editarClienteController: " + ex);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarClienteController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}

	public void onClick$btnApagar(Event ev) {
		try {
			int resp = Messagebox.show(
					Labels.getLabel("editarClienteController.MSG.borrarPergunta"),
					Labels.getLabel("editarClienteController.window.title"),
					Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

			if (resp == Messagebox.YES) {

				clienteService.borrar(cliente);

				Messagebox.show(
						Labels.getLabel("editarClienteController.MSG.borrarOK"),
						Labels.getLabel("editarClienteController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);

				clienteList.removeItem(cliente);

				closeWindow();
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}
	
}
